//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class Continuous2DFunction : TabulatedFunction {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal Continuous2DFunction(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.Continuous2DFunction_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(Continuous2DFunction obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~Continuous2DFunction() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_Continuous2DFunction(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public Continuous2DFunction(int xsize, int ysize, SWIGTYPE_p_std__vectorT_double_t values, double xmin, double xmax, double ymin, double ymax) : this(OpenMMSwigPINVOKE.new_Continuous2DFunction(xsize, ysize, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), xmin, xmax, ymin, ymax), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void getFunctionParameters(SWIGTYPE_p_int xsize, SWIGTYPE_p_int ysize, SWIGTYPE_p_std__vectorT_double_t values, SWIGTYPE_p_double xmin, SWIGTYPE_p_double xmax, SWIGTYPE_p_double ymin, SWIGTYPE_p_double ymax) {
    OpenMMSwigPINVOKE.Continuous2DFunction_getFunctionParameters(swigCPtr, SWIGTYPE_p_int.getCPtr(xsize), SWIGTYPE_p_int.getCPtr(ysize), SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), SWIGTYPE_p_double.getCPtr(xmin), SWIGTYPE_p_double.getCPtr(xmax), SWIGTYPE_p_double.getCPtr(ymin), SWIGTYPE_p_double.getCPtr(ymax));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setFunctionParameters(int xsize, int ysize, SWIGTYPE_p_std__vectorT_double_t values, double xmin, double xmax, double ymin, double ymax) {
    OpenMMSwigPINVOKE.Continuous2DFunction_setFunctionParameters(swigCPtr, xsize, ysize, SWIGTYPE_p_std__vectorT_double_t.getCPtr(values), xmin, xmax, ymin, ymax);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public override TabulatedFunction Copy() {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.Continuous2DFunction_Copy(swigCPtr);
    Continuous2DFunction ret = (cPtr == global::System.IntPtr.Zero) ? null : new Continuous2DFunction(cPtr, false);
    return ret;
  }

}

}
